(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)

























































SetDirectory["C:\\Dokumente und Einstellungen\\rolf\\Eigene \
Dateien\\mymath\\mathwork\\symplecticDL"]





































ssp::usage =
    "ssp[vx,vy] is the symplectic scalar product of two d-dimensional \
vectors; the dimension d= Length[vx] must be even.";

ssp[vx_,vy_] := Module[{ n=Length[vx],d},
    If[Head[vx] \[NotEqual] List|| Head[vy] \[NotEqual] List||OddQ[n]||
        Length[vy]\[NotEqual] n, Print["Incorrect arguments ",vx, vy];
      Return[], Null,Print["Arguments correct?"];Return[]];
    d=n/2;
    Sum[vx[[i]]*vy[[d+i]]-vx[[d+i]]*vy[[i]],{i,1,d}]]













































grammatrix::usage = 
    "grammatrix[b_List] is the matrix of the scalar products of the vectors \
b[[i]] of List b with respect to the scalar product ssp.";

grammatrix[b_List] :=Table[ssp[b[[i]], b[[j]]],{i,Length[b]},{j,Length[b]}]

gram::usage = 
    "gram[d:dim] is Gram's matrix of the scalar products of the standard \
basis in dimension d.";

gram[d_:dim]:= 
  If[EvenQ[d]&& d > 0,grammatrix[IdentityMatrix[d]],
    Print["Incorrect argument!"]; Return[], Print["Argument?"]; Return[]]















































































































ortho::usage = 
    "ortho[b] is a renumbering of the vectors of a symplectic basis b such \
that the result is an orthosymplectic basis. WARNING! ortho[b] yields false \
results if b is not a symplectic basis, without any error message!";

ortho[c_] := Module[{d,b},
    If[MatrixQ[c],d=Length[c],Print["The argument is not a matrix!"];Return[],
      Print["The argument is not a matrix!"];Return[]];
    If[OddQ[d],Print["Incorrect argument ", c];Return[]];
    b= nullmatrix[d];
    For[i= 1,i\[LessEqual] d/2,i++, b[[2*i]]= c[[d/2 + i]];
      b[[2*i-1]]=c[[i]]];
    b]



orthogram::usage=
    "orthogram[d], d even, is the Gram matrix of orthosymplectic bases in the \
d-dimensional symplectic vector space.";

orthogram[d_:dim] := 
  Module[{c = ortho[IdentityMatrix[d]]}, 
    Table[ssp[c[[i]],c[[j]]],{i,d},{j,d}]]























symplectic::usage = 
    "symplectic[b] is a renumbering of the vectors of an orthosymplectic \
basis b such that the result is a symplectic basis. WARNING! symplectic[b] \
yields false results if b is not an orthosymplectic basis, without any error \
message!";

symplectic[c_] := Module[{d,b},
    If[MatrixQ[c],d=Length[c],Print["The argument is not a matrix!"];Return[],
      Print["The argument is not a matrix!"];Return[]];
    If[OddQ[d],Print["Incorrect argument ", c];Return[]];
    b= nullmatrix[d];
    For[i= 1,i\[LessEqual] d/2,i++, b[[i]]= c[[2*i-1]];b[[d/2+i]]=c[[2*i]]];
    b]

















































































orthosymplectic::usage =
    "orthosymplectic is an option for the Module symortho; its default value \
is False. If set to True, symortho yields an orthosymplectic vector sequence, \
and a symplectic one else.";

symortho::usage= 
    "symortho[b]: for a given vector sequence b of a symplectic vector space \
with scalar product ssp the result symortho[b] is a symplectic vector \
sequence with the same span as that of b; setting the option orthosymplectic -> \
True, the resulting sequence is orthosymplectic. The rank and the defect of \
the span of b is calculated and printed, too.";

Options[symortho]={orthosymplectic \[Rule] False};

symortho[a_,opts___]:= Module[{b,bb,m, ea ,iso={}, c={},or},
    or = orthosymplectic /.{opts}/.Options[symortho];
    b=noprops[a];
    If[b\[Equal]  Null, Return[]];
    
    m= Length[b];
    If[m\[Equal]0, Return[b]];
    If[OddQ[Length[b[[1]]]], Print["Incorrect dimension!"];Return[]];
    
    Label[start];
    ea = 0;
    b = outzero[b,10^(-20)];
    m= Length[b];
    
    If[m<= 1, iso=Join[iso,b];Goto[fin]];
    
    For[i=2,i\[LessEqual] m,i++,
      If[ssp[b[[1]],b[[i]]]\[NotEqual] 0,ea = i;Goto[nnn],Null,
        Print["Scalar products may not be evaluated!"];Return[]]];
    
    If[ea\[Equal] 0,
      For[i=2,i\[LessEqual]m,i++, 
        If[wedge[b[[1]],b[[i]]]\[Equal] nullmatrix[], b[[i]]=null[]]];
      AppendTo[iso,b[[1]]];b=Table[b[[i]],{i,2,m}];Goto[start]];
    
    Label[nnn];
    AppendTo[c,b[[1]]];AppendTo[c,b[[ea]]/ssp[b[[1]],b[[ea]]]];
    bb=Join [Table[b[[i]],{i,2,ea-1}],Table[b[[l]],{l,ea+1,m}]];
    m=Length[bb];
    For[i=1,i\[LessEqual] m,i++,
      b[[i]] = bb[[i]] -c[[-2]]*ssp[bb[[i]],c[[-1]]] +
          c[[-1]]*ssp[bb[[i]],c[[-2]]]];
    bb  = Table[Chop[b[[i]]],{i,m}];
    b = noprops[bb];
    Goto[start];
    Label[fin];
    m=Length[c]/2;Print["The rank is ", 2*m];
    ea=Sum[ssp[c[[2*i-1]],c[[2*i]]],{i,m}];
    If[Chop[m-ea] \[NotEqual] 0,
      Print["Scalar products may not be evaluated!"];Return[]];
    If[Length[iso]\[NotEqual] 0,iso = outzero[RowReduce[iso]]];
    Print["The defect is ", Length[iso]];
    ea= Sum[Chop[ssp[c[[i]],iso[[j]]]],{i,2*m},{j,Length[iso]}]+
        Sum[Chop[ssp[iso[[i]],iso[[j]]]],{i,Length[iso]},{j,Length[iso]}];
    If[Chop[ea] \[NotEqual] 0,Print["Scalar products may not be evaluated!"];
      Return[]];
    If[or\[Equal]False&&  c\[NotEqual] {},c=symplectic[c]];
    
    c=Join[c,iso];
    Print["The dimension is ", Length[c]];
    Return[c]]



































































































































































polarspace::usage = 
    "Given a List m of vectors, polarspace[m] is a basis of the vector \
subspace orthogonal to the span of m.";

polarspace[m_List]:= Module[{b},b = Map[(gram[].#)&,m]; Chop[NullSpace[b]]]











































projpt::usage = 
    "projpt[vx] is the point in the affine model of the projective space \
corresponding to the vector vx; if the last component of vx equals 0, projpt \
returns ComplexInfinity.";

projpt[vx_] := Module[{dd = Length[vx], v = vx.vx},
    If[Chop[v] \[Equal] 0, Return["nopt"]];
    If[Chop[vx[[dd]]]\[Equal] 0, Return[ComplexInfinity]];
    Take[vx/vx[[dd]],dd-1]]

















reprprojpt::usage = 
    "vx = reprprojpt[px] is a vector with last component 1 representing the \
projective point px = projpt[vx].";

reprprojpt[a_List] :=Join[a,{1}]









































































projpt3D::usage = 
    "projpt3D[a] is the Graphics primitive Point of the corresponding \
projective point corresponding to the 4-dimensional vector a.";

projpt3D[a_] := Point[projpt[a]]













spherpt3D[a_] := Point[sterproj[dotnorme[a]]]

spherpt3D::usage = 
    "If a is a vector of dimension 4, then spherpt3D[a] is the graphics3D \
primitive Point of the stereographical projection sterproj of the normed \
vector a.";





















transvection::usage = 
    "transvection[b,c] is the symplectic transvection corresponding to the \
vector b and the scalar c.";

transvection[b_,c_][x_] := Module[{bb =Length[b], xx = Length[x]},
    If[bb \[NotEqual] xx|| OddQ[bb], Print["Incorrect arguments!"];Return[]];
    x + b*c*ssp[b,x]]





















transv::usage = "transv[b,c] is the  matrix of transvection[b,c].";

transv[b_,c_] := Transpose[Table[transvection[b,c][stb[i]],{i,dim}]]

















































































































































sym::usage = 
    "sym[x, y, u, v] yields a symplectic invariant of two projective \
symplectic lines spanned by the vectors (x,y) and (u,v) respectively; for \
isotropic lines it is Infinity or Indeterminate.";

sym[x_,y_,u_,v_] :=(ssp[x,u]*ssp[y,v]-ssp[x,v]*ssp[y,u])/(ssp[x,y]*ssp[u,v])





























































































































































bilinear[c_]:= Transpose[c].gram[]











op[b_] := Transpose[b.Inverse[gram[]]]



operator[b_]:= gram[].b





























Clear[a,b,c]; 
skewop[a_,b_,
    c_]:= {{a[[1]],a[[2]],b[[1]],b[[2]]},{a[[3]],a[[4]],b[[2]],b[[3]]},
    {c[[1]],c[[2]],-a[[1]],-a[[3]]},{c[[2]],c[[3]],-a[[2]],-a[[4]]}}















randomabc:= skewop[randomv[],randomv[3],randomv[3]]









Needs["Declare`"]































































































































































































diag[a1_,a2_,a3_,a4_] := DiagonalMatrix[{a1,a2,a3,a4}]









































































nfdiag[x_,y_] := diag[x,y,-x,-y]









bnf4[a_,b_] :=bilinear[nfdiag[a,b]]









q4diag[c_] :=c* x[1] x[3]+x[2] x[4]==0









mqj2[a_] := {{a,0,0,0},{1,a,0,0},{0,0,-a,-1},{0,0,0,-a}}









bqj2[a_] := bilinear[mqj2[a]]



Simplify[vec[x].bqj2[a].vec[x]]\[Equal] 0

































































































































































































































































































































dim::usage = "dim is the dimension of the vector space under consideration; \
it must be set within the Global Context."

stb::usage="stb[i, d:dim] is the i-th standard basis vector, 1 <= i <= d.";

stb[i_Integer,d_:dim]:=IdentityMatrix[d][[i]]

vec::usage ="vec[x, n:dim] is the n-vector with components x[i].";

vec[x_, n_:dim] := Array[x,  n]

null::usage = "null[d:dim] is the zero vector of length d.";

null[d_:dim] :=Table[0,{d}]

dotnorme::usage="dotnorme[b] yields the unit vector with respect to the Dot
product in direction of b, b!=o.";

dotnorme[b_]:=b/Sqrt[b.b]

sterproj::usage="sterproj is the stereographical projection of the unit 
n-sphere from the north pole stb[n+1] onto the euclidean (equatorial) \
n-space. 
WARNING: The result is correct only for arguments of norm 1 !";

sterproj[v_List]:=Module[{m=Length[v],l,w},l=null[m];
    w=v[[m]];
    If[smoothing[w-1]\[Equal]0,For[i=1,i<m,i++,l[[i]]=Infinity],
      l=Simplify[stb[m,m]+(v-stb[m,m])/(1-w)],
      l=Simplify[stb[m,m]+(v-stb[m,m])/(1-w)]];
    l=Take[l,m-1];
    l]

invsterproj::usage="invsterproj is the inverse of the general euclidean 
stereographic projection sterproj.";

invsterproj[y_List]:=
  Module[{n=Length[y]+1,x=Append[y,0],u=y.y},x*2/(1+u)+stb[n,n]*(u-1)/(u+1)]




randomv::usage=
    "randomv[n:dim] is a random n-vector with values in the  positive unit \
n-cube.";

randomv[n_:dim] := Table[Random[],{i, n}]





wedge::usage = 
    "wedge[a,b] is the alternate product of vectors a,b given by the matrix \
of its coordinates.";

wedge[a_,b_]:= 
  Module[{d=Length[a]},Table[a[[i]]*b[[j]]-a[[j]]*b[[i]],{i,1,d},{j,1,d}]]







basis::usage="basis[v] yields a sublist of v being a basis of the span of 
the vectors v[[i]]of v; v must be a matrix.";

basis[v_]:=
  Module[{r,l,w,i,fdrop},
    If[Not[MatrixQ[v]],Print["Argument is not a matrix, no span!"];Return[]];
    r=rank[v];
    If[r\[Equal]0,Print["The span is the null space!"];Return[]];
    w=outzero[v, 10^(-20)];
    fdrop[i_]:=Drop[w,{i}];
    Label[new];
    l=Length[w];
    If[r\[Equal]l,Return[w]];
    For[i=1,i\[LessEqual]l,i++,
      If[rank[fdrop[i]]\[Equal]r,w=fdrop[i];Goto[new]]]]

outzero::usage=
    "outzero[b_List,dd] is the sublist of the vectors b[[i]] with \
Abs[b[[i]].b[[i]]] > dd; the default value of dd is 10^(-20).";

outzero[b_List, dd_:10^(-20)]:=
  Module[{v={},l=Length[b]},
    For[i=1,i\[LessEqual]l,i++,
      If[Not[Chop[b[[i]].b[[i]],dd]\[Equal]0],AppendTo[v,b[[i]]],Null[],
        AppendTo[v,b[[i]]]]];Return[v]]







noprops::usage = 
    "noprops[c] deletes lines c[[j]] of the matrix c which are proportional \
to an element c[[i]] with i<j, and returns the matrix originated that way.";

noprops[c_]:= Module[{m=1,cc, d},
    If[Length[c]\[LessEqual]1,Return[c]];
    If[Not[MatrixQ[c]], Print["incorrect argument!"];Return[]];
    d=Length[c[[1]]];
    cc=outzero[c];
    If[Length[cc]\[LessEqual]1,Return[cc]];
    Label[ttt];
    For[j=m+1,j\[LessEqual] Length[cc],j++, 
      If[Chop[wedge[cc[[m]],cc[[j]]],10^(-20)]\[Equal] nullmatrix[d],
        cc[[j]]=null[d]]];
    cc=outzero[cc];m = m+1;
    If[Length[cc] \[LessEqual] m, Return[cc],Goto[ttt]]]











































matrix::usage = "matrix[b,n:dim] is a square matrix of order n with elements \
b[i,j]."

matrix[b_,n_:dim]:= Array[b,{n,n}]



nullmatrix::usage = 
    "nullmatrix[d] is the square nullmatrix of order d; the default value of \
d is dim.";

nullmatrix[d_:dim]:= Table[0,{i,1,d},{j,1,d}]









blf::usage = 
    "blf[a, d:dim] is a symmetric matrix of order d with elements a[i,j].";

blf[a_,d_:dim]:= Module[{b = matrix[a]},
    For[i = 1,i<d,i++,For[j=i+1,j\[LessEqual]d,j++,a[j,i]=a[i,j]]];
    b]









rank::usage="rank[m] calculates the rank of the rectangular matrix m of a not
 too large order (< 10000).";

rank[m_] := Module[{ di , nsp},
    If[Not[MatrixQ[m]], Print["incorrect argument!"];Return[]];
    di = Length[m[[1]]];
                  nsp = NullSpace[m];
               di - Length[nsp]]

















randommatrix::usage = 
    "randommatrix[k,l]is a matrix with k rows and l columns, with random \
elements out of the unit intervall.";

randommatrix[k_,l_] := Table[randomv[l], {k}]









trp::usage = "trp[i,j,n:dim] is the unit matrix of order n where the i-th and \
the j-th row are transposed." 

trp[i_,j_,n_:dim]:=Module[{m=IdentityMatrix[n]}, m[[i]]=stb[j,n];
    m[[j]]=stb[i,n];
    m]





























refl[i_,n_:dim] :=Module[{mm=IdentityMatrix[n]},
    mm[[i,i]]= -1;
    mm]



















